#line 1 "C:/Evil Genius/MikroProC/16F688/HAL with Speech/HALwSpeech.c"
#line 1 "c:/evil genius/mikroproc/16f688/hal with speech/delay_sub.h"




void Delay5us()
{
Delay_us(5);
}

void Delay20us()
{
Delay_us(20);
}

void Delay50us()
{
Delay_us(50);
}

void Delay2ms()
{
Delay_ms(2);
}

void Delay5ms()
{
Delay_ms(5);
}

void Delay10ms()
{
Delay_ms(10);
}

void Delay50ms()
{
Delay_ms(50);
}

void Delay100ms()
{
Delay_ms(100);
}

void Delay500ms()
{
Delay_ms(500);
}

void Delay1000ms()
{
Delay_ms(1000);
}

void Delay2000ms()
{
Delay_ms(2000);
}

void Delay3000ms()
{
Delay_ms(3000);
}
#line 1 "c:/evil genius/mikroproc/16f688/hal with speech/speakjet_serial.h"
#line 12 "c:/evil genius/mikroproc/16f688/hal with speech/speakjet_serial.h"
void Speakjet_Transmit(const char s[])
{
 unsigned char i;

 for (i = 0; s[i] != 0; i++)
 {
 Soft_Uart_Write(s[i]);
 while ( PORTC.F2  == 1)
 {
 }
 Delay10ms();
 }
 return;
}

void Speakjet_Reset()
{
  PORTC.F3  = 1;
 Delay100ms();
  PORTC.F3  = 0;
 Delay100ms();
  PORTC.F3  = 1;
 Delay100ms();
 return;
}
#line 1 "c:/evil genius/mikroproc/16f688/hal with speech/phonemes.h"
#line 1 "c:/evil genius/mikroproc/16f688/hal with speech/phrases.h"









const char _yesdave[] =
 {
  22 ,85, 158 ,  187 ,  187 ,  1 ,
  22 ,75,  174 ,  8 ,  154 ,  166 ,  166 ,  2 , 0};


const char _morningdave[] =
 {
  22 ,85,  179 ,  138 ,  138 ,  177 ,  1 ,
  22 ,95,  140 ,  7 ,  137 ,  7 ,  153 ,  141 ,  129 ,  143 , 2 ,
  22 ,75,  174 ,  8 ,  154 ,  166 ,  166 ,  2 , 0};


const char _hellodave[] =
 {
  22 ,85,  183 ,  8 ,  159 ,  146 ,  164 ,  1 ,
  22 ,80,  174 ,  8 ,  154 ,  166 ,  166 ,  2 , 0};


const char _daisy[] =
 {
  22 ,85,  174 ,  154 ,  8 ,  167 ,  7 ,  128 ,  2 ,
  22 ,70,  174 ,  154 ,  8 ,  167 ,  7 ,  128 ,  2 , 0};


const char _sorrydave[] =
 {
  22 ,100,  157 ,  8 ,  140 ,  1 ,
  22 ,112,  8 ,  188 ,  136 ,  148 ,  7 ,  128  , 2 ,
  22 ,80,  174 ,  8  , 154 ,  166 ,  166 ,  2 , 0};
#line 1 "c:/evil genius/mikroproc/16f688/hal with speech/slcd.h"
#line 17 "c:/evil genius/mikroproc/16f688/hal with speech/slcd.h"
const sLCD_FIRST_ROW = 128;
const sLCD_SECOND_ROW = 192;
const sLCD_THIRD_ROW = 148;
const sLCD_FOURTH_ROW = 212;
const sLCD_CLEAR = 1;
const sLCD_RETURN_HOME = 2;
const sLCD_CURSOR_OFF = 12;
const sLCD_UNDERLINE_ON = 14;
const sLCD_BLINK_CURSOR_ON = 15;
const sLCD_MOVE_CURSOR_LEFT = 16;
const sLCD_MOVE_CURSOR_RIGHT = 20;
const sLCD_TURN_OFF = 0;
const sLCD_TURN_ON = 8;
const sLCD_SHIFT_LEFT = 24;
const sLCD_SHIFT_RIGHT = 28;


void Nybble(unsigned char LCDOut, unsigned char RS)

{
unsigned char i;
  PORTA.F5  = 0;
 for (i = 0; i < 6; i++)
 {
  PORTA.F4  = 1;
 Delay5us();
  PORTA.F4  = 0;
 }
 LCDOut = LCDOut | (1 << 5) | ((RS & 1) * (1 << 4));
 for (i = 0; i < 6; i++)
 {
 if (0 != (LCDOut & (1 << 5)))
  PORTA.F5  = 1;
 else
  PORTA.F5  = 0;
 LCDOut = LCDOut << 1;
  PORTA.F4  = 1;
 Delay5us();
  PORTA.F4  = 0;
 }
  PORTA.F5  = 1;
  PORTA.F5  = 1;
  PORTA.F5  = 0;
  PORTA.F5  = 0;

}


void sLCDWrite(unsigned char LCDData, unsigned char RSValue)

{
 Nybble((LCDData >> 4) & 0x0F, RSValue);
 Nybble(LCDData & 0x0F, RSValue);
 if ((0 == (LCDData & 0xFC)) && (0 == RSValue))
 Delay20us();
 else
 Delay20us();
}


void sLCD_Chr(unsigned char row, unsigned char col, unsigned char character)

{
 if (row == 1) row = 128;
 if (row == 2) row = 192;
 if (row == 3) row = 148;
 if (row == 4) row = 212;
 sLCDWrite((row + (col - 1)), 0);
 sLCDWrite(character, 1);
}


void sLCD_Chr_Cp(unsigned char character)

{
 sLCDWrite(character, 1);
}


void sLCD_Cmd(unsigned char instruction)

{
 sLCDWrite (instruction, 0);
}


void sMove_Cursor(unsigned char row, unsigned char col)

{
 if (row == 1) row = 128;
 if (row == 2) row = 192;
 if (row == 3) row = 148;
 if (row == 4) row = 212;
 sLCDWrite((row + (col - 1)), 0);
}


int NumtoChar(unsigned char val)
{
 unsigned char ch;
 if (val < 10)
 {
 ch = val + '0';
 }
 else
 {
 val = val - 10;
 ch = val + 'A';
 }
 return(ch);
}


void sResetLCD()

{
 sLCDWrite(0b00000001, 0);
 Delay5ms();
 sLCDWrite(0b00000110, 0);
 Delay5ms();
 sLCDWrite(0b00001100, 0);
 Delay5ms();
}


void sLCD_Out(unsigned char row, unsigned char col, const char s[])


{
 char i;
 if (row == 1) row = 128;
 if (row == 2) row = 192;
 if (row == 3) row = 148;
 if (row == 4) row = 212;
 sLCDWrite(row + (col - 1), 0);
 for (i = 0; s[i] != 0; i++)
 {
 sLCDWrite(s[i], 1);
 }
}

void sLCD_Outn(unsigned char row, unsigned char col, char *s)


{
 char i;
 if (row == 1) row = 128;
 if (row == 2) row = 192;
 if (row == 3) row = 148;
 if (row == 4) row = 212;
 sLCDWrite(row + (col - 1), 0);
 for (i = 0; s[i] != 0; i++)
 {
 sLCDWrite(s[i], 1);
 }
}


void sLCD_Out_Cp(const char s[])



{
 int i;

 for (i = 0; s[i] != 0; i++)
 {
 sLCDWrite(s[i], 1);
 }
}


void sLCDtoBCD(long int val, unsigned char digits)

{
 int d;
 unsigned char ch;

 if (digits == 5)
 {
 d = val/10000;
 ch = NumtoChar(d);
 sLCDWrite(ch, 1);
 }
 if (digits > 3)
 {
 val = val%10000;
 d = val/1000;
 ch = NumtoChar(d);
 sLCDWrite(ch, 1);
 }
 if (digits > 2)
 {
 val = val%1000;
 d = val/100;
 ch = NumtoChar(d);
 sLCDWrite(ch, 1);
 }
 if (digits > 1)
 {
 val = val%100;
 d = val/10;
 ch = NumtoChar(d);
 sLCDWrite(ch, 1);
 }
 if (digits == 1)
 {
 val = val%100;
 }
 d = val % 10;
 ch = NumtoChar(d);
 sLCDWrite(ch, 1);
}




void Init_sDisplay()
{
char i;
 for (i = 0; i < 3; i++)
 {
 Delay10ms();
 Nybble(3, 0);
 }
 Nybble(2, 0);
 Delay10ms();
}
#line 1 "c:/evil genius/mikroproc/16f688/hal with speech/x10.h"
#line 23 "c:/evil genius/mikroproc/16f688/hal with speech/x10.h"
char const House_Code_Table[17] = {'M','N','O','P','C','D','A','B','E',
 'F','G','H','K','L','I','J'};
char const Unit_Code_Table[18] = {13, 14, 15, 16, 3, 4, 1, 2, 5, 6, 7,
 8, 11, 12, 9, 10};
char txt4[4], temp, tempkeypad, setbit;
char house_code, unit_code;

char shiftRight(char number)
{
 return number >>= 1;
}

char x10_data_ready()
{
 return (! PORTA.F2 );
}

void x10_zero_cross()
{
 if( PORTA.F0 )
 while( PORTA.F0 ) ;
 else
 while(! PORTA.F0 ) ;
}

void x10_trans_bits(char bit_val, char numofbits, char startbit)
{
 char loopcount;

 for(loopcount = 1; loopcount <= numofbits; ++loopcount)
 {
 x10_zero_cross();
 bit_val = shiftRight(bit_val);
  PORTA.F1  = bit_val.F0;
 delay_ms(1);
  PORTA.F1  = 0;
 if(startbit == 0)
 {
 x10_zero_cross();
  PORTA.F1  = !bit_val.F0;
 delay_ms(1);
  PORTA.F1  = 0;
 }
 }
 return;
}

void x10_send_data(char house_code2, char unit_code2)
{
 char i;
 i = 0;
 while (House_Code_Table[i] != house_code2)
 i++;
 house_code2 = i;
 if(unit_code2 <= 16)
 {
 i = 0;
 while (Unit_Code_Table[i] != unit_code2)
 i++;
 unit_code2 = i;
 }
 x10_trans_bits(7 * 2, 4, 1);
 x10_trans_bits(house_code2 * 2, 4, 0);
 x10_trans_bits(unit_code2 * 2, 5, 0);
 x10_trans_bits(0, 6, 1);
 return;
}

char x10_read_bits(char num_of_bits)
{
char ic, dataval;

 for(ic = 1; ic <= num_of_bits; ++ic)
 {
 x10_zero_cross();
 delay_us(710);
 if ( PORTA.F2  == 1)
 {
 setbit = 128;
 }
 else
 {
 setbit = 0;
 }
 dataval = dataval + setbit;
 dataval = shiftRight(dataval);
 x10_zero_cross();
 delay_us(710);
 }
 for(ic = 0; ic < 7 - num_of_bits; ++ic)
 {
 dataval = shiftRight(dataval);
 }
 return(dataval);
}

void x10_read_pulse_code()
{
 x10_read_bits(2);
 house_code = x10_read_bits(4);
 house_code = House_Code_Table[house_code];
 unit_code = x10_read_bits(5);
 if(unit_code < 16)
 unit_code = Unit_Code_Table[unit_code];
}
#line 1 "c:/evil genius/mikroproc/16f688/hal with speech/vrbot_protocol.h"
#line 1 "c:/evil genius/mikroproc/16f688/hal with speech/vrbot.h"






char VRbot_Detect(void);
char VRbot_SetLanguage(char lang);
void VRbot_RecognizeSI(char ws);
void VRbot_RecognizeSD(char group);
signed char VRbot_CheckResult(void);
char VRbot_GetGroupCount(char group);


char VRbot_Detect()
{
 char i;
 for (i = 0; i < 9; ++i)
 {
 Uart1_Write( 'b' );
 Delay100ms();
 if (Uart1_Data_Ready() && Uart1_Read() ==  'o' )
 return 255;
 }
 return 0;
}

char VRbot_SetLanguage(char lang)
{
 Uart1_Write( 'l' );
 Delay5ms();
 Uart1_Write( 0x41  + lang);
 Delay100ms();

 if (Uart1_Data_Ready() && Uart1_Read() ==  'o' )
 return 255;
 return 0;
}

void VRbot_RecognizeSD(char group)
{
 Uart1_Write( 'd' );
 Delay5ms();
 Uart1_Write( 0x41  + group);
}

void VRbot_RecognizeSI(char ws)
{
 Uart1_Write( 'i' );
 Delay5ms();
 Uart1_Write( 0x41  + ws);
}

signed char VRbot_CheckResult(void)
{
 char rxc;
 if (!Uart1_Data_Ready())
 return -1;
 rxc = Uart1_Read();
 if (rxc ==  's'  || rxc ==  'r' )
 {
 Delay5ms();
 Uart1_Write( 0x20 );
 while (!Uart1_Data_Ready());
 return Uart1_Read() -  0x41 ;
 }
 return -2;
}

char VRbot_GetGroupCount(char group)
{
 char rxcc;
 Uart1_Write( 'c' );
 Delay5ms();
 Uart1_Write( 0x41  + group);
 Delay100ms();
 if (!Uart1_Data_Ready())
 return 0;
 rxcc = Uart1_Read();
 if (rxcc ==  'c' )
 {
 Delay5ms();
 Uart1_Write( 0x20 );
 while (!Uart1_Data_Ready());
 return Uart1_Read() -  0x41 ;
 }
 return 0;
}
#line 30 "C:/Evil Genius/MikroProC/16F688/HAL with Speech/HALwSpeech.c"
char dummy, chan, OnOff, mode;
signed char res, res1;
char House;
char DimVal = 0;
char txt[4];

const char Message1[17] = "HAL the Butler  ";
const char Message2[17] = "P16F688   by RCI";
const char Message3[17] = "HAL is Activated";
const char Message4[17] = "Scanning...";
const char Message5[17] = "Transmitting X10";
const char Message6[17] = "Program Mode    ";
const char Message12[17] = "HAL is Ready!   ";
const char Message99[17] = "                ";
const char HelloDave[] = {22, 85, 158, 187, 1, 22, 70, 174, 7, 154, 166, 166, 0};



const char *WordSD0[] = {"HAL             ",
 "Robot           ",
 "                "};

const char *WordSD1[] = {"Living Room     ",
 "Piano Room      ",
 "Kitchen         ",
 "Porch           ",
 "Bedroom         ",
 "Fan             ",
 "Bathroom        ",
 "Hallway         ",
 "Dining Room     ",
 "Coffee Pot      ",
 "Christmas Tree  ",
 "Pond Lights     ",
 "                "};

const char *WordSD2[] = {"ON              ",
 "OFF             ",
 "Dim Lights      ",
 "                "};



void Get_SD_Commands(void)
{
 char group = 0;
 while (VRbot_GetGroupCount(group) == 0)
 {
 }
wait_sd:

 VRbot_RecognizeSD(group);
 BytetoStr(group, txt);
 sLCD_Outn(2, 14, txt);

while (1 == 1)
{
 res = VRbot_CheckResult();
 sLCD_Out(2, 1, Message4);
 if ((res < -1) && (group > 0))
 {
 Speakjet_Transmit(_sorrydave);
 group = 0;
 goto wait_sd;
 }
 if (res < -1)
 goto wait_sd;


 if(group == 0)
 {
 if (res >= 0)
 {
 sLCD_Out(2, 1, WordSD0[res]);
 Speakjet_Transmit(_yesdave);
 Delay1000ms();
 sLCD_Out(2, 1, Message99);
 group = 1;
 goto wait_sd;
 }
 }


 if(group == 1)
 {
 if (res >= 0)
 {
 if (res == 0)
 {
 chan = 2;
 }
 if (res == 1)
 {
 chan = 10;
 }
 if (res == 2)
 {
 chan = 4;
 }
 if (res == 3)
 {
 chan = 9;
 }
 if (res == 4)
 {
 chan = 5;
 }
 if (res == 5)
 {
 chan = 8;
 }
 if (res == 6)
 {
 chan = 6;
 }
 if (res == 7)
 {
 chan = 7;
 }
 if (res == 8)
 {
 chan = 14;
 }
 if (res == 9)
 {
 chan = 15;
 }
 if (res == 10)
 {
 chan = 3;
 }
 if (res == 11)
 {
 chan = 11;
 }
 sLCD_Out(2, 1, WordSD1[res]);
 Speakjet_Transmit(_yesdave);
 Delay1000ms();
 sLCD_Out(2, 1, Message99);
 group = 2;
 goto wait_sd;
 }
 }


 if(group == 2)
 {
 if (res >= 0)
 {
 if (res == 0)
 {
 OnOff = 20;
 }
 if (res == 1)
 {
 OnOff = 28;
 }
 sLCD_Out(2, 1, WordSD2[res]);
 Speakjet_Transmit(_yesdave);
 Delay1000ms();
 sLCD_Out(2, 1, Message99);
 group = 0;
 mode = 3;
 goto trans;
 }
 }
  PORTC.F0  = 1;
 Delay100ms();
  PORTC.F0  = 0;
 Delay100ms();
 }
trans:
 return;
}

void x10Trans(char House, char Chan, char OnOff, char DimVal)
{
 x10_send_data(House, Chan);
 x10_send_data(House, Chan);
 Delay500ms();
 x10_send_data(House, OnOff);
 x10_send_data(House, OnOff);
}

void main(void)
{

 ANSEL = 0b00000000;
 PORTA = 0b00000000;
 PORTC = 0b00000000;
 CMCON0 = 0b00000111;
 OSCCON = 0b01110001;
 Uart1_Init(9600);
 Soft_Uart_Init(&PORTA, 7, 2, 9600, 0);
 TRISA = 0b00001001;
 TRISC = 0b00100010;
 mode = 1;
 House = 'A';
 Init_sDisplay();
 Delay100ms();
 sResetLCD();
 Delay100ms();
 Speakjet_Reset();
 sLCD_Out(1, 1, Message1);
 sLCD_Out(2, 1, Message2);
 Delay2000ms();
 Speakjet_Transmit(_morningdave);
 Delay2000ms();


loop:
 sLCD_Out(2, 1, Message6);
 if (VRbot_Detect())
 {
 sLCD_Out(1, 1, Message3);
 sLCD_Out(2, 1, Message99);
 Delay2000ms();
 goto start;
 }
 Delay500ms();
goto loop;
start:

while (1 == 1)
 {

switch(mode)
 {

case 1:
 sLCD_Out(1, 1, Message12);
 sLCD_Out(2, 1, Message99);
 Delay1000ms();
 Get_SD_Commands();
 break;

case 2:



break;

case 3:

 sLCD_Out(1, 1, Message99);
 sLCD_Out(2, 1, Message5);
 x10Trans(House, chan, OnOff, 0);
 Delay100ms();
 DimVal = 0;
 OnOff = 0;
 chan = 0;
 mode = 1;

break;


 }
 }
}
