//****************************************************************************
void Get_SI_Commands(void)
{
char group = 0;
wait_si:

	VRbot_RecognizeSI(group);            // Check Speaker Dependant Group 0
  BytetoStr(group, txt);               // Display Group Value
	sLCD_Outn(2, 14, txt);
//*** Loop Here to Scan for Words within a Group *******
while (1 == 1)
{
		res = VRbot_CheckResult();         // Get Response from VRBOT
		sLCD_Out(2, 1, Message6);          // Display "Scanning"
		if ((res < -1) && (group > 0))     // If command not understood
      {
      Sound_Play(1000, 100);           // Beep 3 times
      Delay100ms();
      Sound_Play(1000, 100);
      Delay100ms();
      Sound_Play(1000, 500);
      Delay100ms();
      group = 0;                       // Go Wait for another Group 0 command
      goto wait_si;
			}
		if (res < -1)
			goto wait_si;
//******************************************************
// If Response to "HAL" is Valid,  Display Request for Command
    if(group == 0)
    {
		if (res >= 0)
      {
      if (res == 0)                   // HAL
         {
         sLCD_Out(2, 1, WordSD0[res]);
         Sound_Play(1000, 500);
			   Delay_ms(1000);
	       sLCD_Out(2, 1, Message99);
	       group = 1;
			   goto wait_si;
		     }
		  }
    } // End If Group
//******************************************************
// If Room Response is Valid,  Display Recalled Room Data
    if(group == 1)
    {
		if (res >= 0)
      {
      if (res == 0)     // Action
         {
         chan = 1;
         }
      if (res == 1)     // Move
         {
         chan = 1;
         }
      if (res == 2)     // Turn
         {
         chan = 1;
         }
      if (res == 3)     // Run
         {
         chan = 1;
         }
      if (res == 4)     // Look
         {
         chan = 1;
         }
      if (res == 5)     // Attack
         {
         chan = 1;
         }
      if (res == 6)     // Stop
         {
         chan = 1;
         }
      if (res == 7)     // Hello
         {
         chan = 1;
         }
      sLCD_Out(2, 1, WordSI1[res]);  //  Room
      Sound_Play(1000, 500);
			Delay_ms(500);
	    sLCD_Out(2, 1, Message99);
	    group = 2;
			goto wait_si;
		  }
    } // End If Group
//*******************************************************
// If Room Response is Valid,  Display Recalled Room Data
    if(group == 2)
    {
		if (res >= 0)
      {
      if (res == 0)    // Left
         {
         chan = 1;
         }
      if (res == 1)    // Right
         {
         chan = 1;
         }
      if (res == 2)    // UP
         {
          chan = 1;
         }
      if (res == 3)    // Down
         {
         chan = 1;
         }
      if (res == 4)    // Forward
         {
          chan = 1;
         }
      if (res == 5)    // Backward
         {
         chan = 1;
         }
      sLCD_Out(2, 1, WordSI2[res]);  //  Display Direction
      Sound_Play(1000, 500);
			Delay_ms(500);
	    sLCD_Out(2, 1, Message99);
	    group = 2;
			goto wait_si;
		  }
    } // End If Group
//******************************************************
// If ON/OFF Command Response is Valid,  Display Recall Light Value
    if(group == 3)
    {                                // If VRBot Group
		if (res >= 0)
      {
      if (res == 0)     // Zero
         {
         chan = 1;
         }
      if (res == 1)     // One
         {
         chan = 1;
         }
      if (res == 2)     // Two
         {
         chan = 1;
         }
      if (res == 3)     // Three
         {
         chan = 1;
         }
      if (res == 4)     // Four
         {
         chan = 1;
         }
      if (res == 5)     // Five
         {
         chan = 1;
         }
      if (res == 6)     // Six
         {
         chan = 1;
         }
      if (res == 7)     // Seven
         {
         chan = 1;
         }
      if (res == 8)     // Eight
         {
         chan = 1;
         }
      if (res == 9)     // Nine
         {
         chan = 1;
         }
      if (res == 10)     // Ten
         {
         chan = 1;
         }
      sLCD_Out(2, 1, WordSI3[res]);  // Display SI Numbers
      Sound_Play(1000, 500);         // Beep once if command is good
      Delay_ms(500);
	    sLCD_Out(2, 1, Message99);
	    group = 0;                     // Reset group for another round
	    mode = 3;                      // Set mode for x10 transmit
	    goto trans1;
		  }
    } // End If Group
  PORTD.F3 = 1;                      // While waiting for valid command.....
  Delay100ms();                      // Pulse LED to show HAL is scanning
  PORTD.F3 = 0;
  Delay100ms();
	} // End While
trans1:
      return;                        // Send x10 data to Basic Stamp
} // End Demo_SD